require 'image_mosaic/version'
require 'mini_magick'
require 'tempfile'
require 'securerandom'
require 'image_mosaic/data/background'
require 'image_mosaic/data/validator'
require 'image_mosaic/image/child'
require 'image_mosaic/image/mosaic'
require 'image_mosaic/image/parent'
require 'image_mosaic/image/layout/grid'
require 'image_mosaic/operations/compositor'
require 'image_mosaic/operations/construct'
require 'image_mosaic/railtie' if defined?(Rails)

module ImageMosaic
  WIDTH = 1000
  COLOUR = '#ffffff'.freeze
  LAYOUT = 'grid'.freeze

  def self.create(items, layout: LAYOUT, colour: COLOUR, width: WIDTH)
    Operations::Construct.new(items, layout: layout, colour: colour, width: width).parent
  end
end
