module ImageMosaic
  module Operations
    # Takes a composite_image
    # Can then place another image over the top at x, y coordinates and resized to a dimension.
    class Compositor
      def initialize(composite_image, child)
        @composite_image = composite_image
        @child = child
      end

      def save(type: 'Over')
        @composite_image.composite(image) do |composite|
          composite.compose type
          composite.geometry "+#{@child[:x]}+#{@child[:y]}"
        end
      end

      private

      def image
        @image ||= MiniMagick::Image.open(@child[:url]).resize "#{@child[:w]}x#{@child[:h]}^"
      end
    end
  end
end
