module ImageMosaic
  module Operations
    class Construct
      def initialize(items, layout: LAYOUT, colour: COLOUR, width: WIDTH)
        @items = items
        @layout = layout
        @colour = colour
        @width = width
      end

      def parent
        @parent ||= Image::Parent.new(layout_items, colour: @colour, width: @width).create
      end

      private

      def background
        @background ||= Data::Background.new(@colour).hex
      end

      def layout_items
        @layout_items ||= layout_klass.new(@items, width: @width).items
      end

      def layout_klass
        Kernel.const_get("ImageMosaic::Image::Layout::#{@layout.split('_').collect(&:capitalize).join}")
      end
    end
  end
end
